#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>

using namespace std;

class Liige {
    string enimi;
    string pnimi;
    string fraktsioon;
public:
    Liige(string e, string p, string f)
    {
        enimi=e; pnimi=p;fraktsioon=f;
    }
    string anna_enimi() {  return enimi;}
    string anna_pnimi() { return pnimi;}
    string anna_fraktsioon() { return fraktsioon;}

    bool equals(Liige *keegi)
    {
        return enimi.compare(keegi->enimi)==0
                   and pnimi.compare(keegi->pnimi)==0
                   and fraktsioon.compare(keegi->fraktsioon)==0;
    }

    // Liikme kirjeldus tekstina
    string toString()
    {
        return this->enimi+" "+this->pnimi+"\t"+this->fraktsioon;
    }
};
struct Eesnimi {
    string nimi;
    int sagedus;
};
struct Fraktsioon
{
    string nimetus;
    vector<Liige*> fliikmed;
    string toString()
    {
        stringstream ss;
        ss<<"\t"<<nimetus<<" - "<<fliikmed.size()<<" liiget\n";
        for(int i=0;i<fliikmed.size();i++)
                ss<<"\t\t\t"<<fliikmed[i]->anna_enimi()<<" "<<fliikmed[i]->anna_pnimi()<<endl;

        return ss.str();
    }
};
class Riigikogu
{
    vector<Liige*> liikmed;
    vector<Eesnimi> eesnimed;
    vector<Fraktsioon*> fraktsioonid;

public:
    // Riikogu kirjeldus stringina
    string toString()
    {
        stringstream ss;
        ss << "Riigikogu "<<liikmed.size()<<" liiget:";

        string result = ss.str();
        for(int i=0;i<liikmed.size();i++)
            result += "\n"+liikmed[i]->toString();   // this = liikmed[i];

        return result;

    }


    void lisa_fraktsiooni(Liige *uus)
    {
        string fnimi = uus->anna_fraktsioon();
        for(int k=0;k<fraktsioonid.size();k++)
        {
            if(fnimi.compare(fraktsioonid[k]->nimetus) == 0)
            {
                fraktsioonid[k]->fliikmed.push_back(uus);
                return;
            }
        }
        Fraktsioon *f = new Fraktsioon();
        f->nimetus = fnimi;
        f->fliikmed.push_back(uus);
        fraktsioonid.push_back(f);


    }
    void lisa_eesnimi(string name)
    {
        for(int j=0;j<eesnimed.size();j++)
            if(name.compare(eesnimed[j].nimi)==0)
            {
                eesnimed[j].sagedus++;
                return;
            }

        Eesnimi keegi;
        keegi.nimi=name;
        keegi.sagedus=1;
        eesnimed.push_back(keegi);
    }

    void lisa_liige(Liige *uus)
    {
        liikmed.push_back(uus);
        lisa_eesnimi(uus->anna_enimi());
        lisa_fraktsiooni(uus);
    }
    void prindi_eesnimed()
    {
        int popim = 0;
        vector<string> popimad;
        for(int j=0;j<eesnimed.size();j++)
        {
            cout<<eesnimed[j].sagedus<<"\t"<<eesnimed[j].nimi<<endl;
            if(eesnimed[j].sagedus>=popim)
            {
                if(eesnimed[j].sagedus>popim)
                {
                    popim = eesnimed[j].sagedus;
                    popimad.clear();
                }
                popimad.push_back(eesnimed[j].nimi);
            }
        }

        for(int j=0;j<popimad.size();j++)
        {
            string pop_nimi = popimad[j];
            for(int i=0;i<liikmed.size();i++)
                if(pop_nimi.compare(liikmed[i]->anna_enimi())==0)
                    cout<<pop_nimi<<" "<<liikmed[i]->anna_pnimi()<<endl;
        }

    }
    void prindi_fraktsioonid()
    {
        cout << "\n                           *** FRAKTSIOONID ***\n";
        for(int k=0;k<fraktsioonid.size();k++)
            cout<<fraktsioonid[k]->toString();


    }
};







int main()
{
    ifstream nimekiri("M:\\Kaarel.Allik\\COOP\\Harjutused\\Riigikogu.txt");
    if(not nimekiri.is_open())
    {
        cout<<"Faili ei saa avada.\n";
        return 1;
    }
    Riigikogu kogu;
    while(nimekiri.good())
    {
        string e, p, f;
        nimekiri>>e;
        // lisame eesnimede registrisse
        //lisa_eesnimi(e);
        nimekiri>>p;

        string rida;
        getline(nimekiri,rida);
        getline(nimekiri,rida);  // nimi teist korda
        getline(nimekiri,f);
        Liige *keegi = new Liige(e,p,f);
        kogu.lisa_liige(keegi);

        cout<<keegi->anna_enimi()<<" "<<keegi->anna_pnimi()
               <<" "<<keegi->anna_fraktsioon()<<endl;

        do {
            getline(nimekiri,rida);
        } while(rida.length());
    }
    kogu.prindi_eesnimed();

    cout<<kogu.toString()<<endl;

     kogu.prindi_fraktsioonid();


    return 0;
}
